/*
 * 说明:通用JS 文件，包括多种业务处理
 * 版本：V.1.0.0
 * 日期：2017-08-25
 * 作者：80002480
 */
define(["zepto"],function($){

	//页面初始化设置  VP.js
	(function(){
	    var html = document.documentElement,
	        meta = document.querySelector('meta[name="viewport"]');
	    function init(dpr,flag){
	        //var scale = 1 / dpr;
	        var scale = 1;
	        var vw = html.clientWidth,
	            vh = html.clientHeight;
	        // if (flag) {
	        //     vw = html.clientWidth / dpr;
	        // }
	        vw = vw < 320 ? 320 : vw;
	        vw = vw > 640 ? 640 : vw;
	        //var rem = vw * dpr / 64 * 2;
	        var rem = vw / 640 * 20;

	        html.setAttribute("data-dpr", dpr);// 动态写入样式
	        //meta.setAttribute('content', 'width=' + "device-width" + ',initial-scale=' + scale + ',maximum-scale=' + scale + ', minimum-scale=' + scale + ',user-scalable=no');// 设置data-dpr属性，留作的css hack之用
	        html.style.fontSize = rem + "px";
	        window.vw = vw;
	        window.vh = vh;
	    }
	    init(window.devicePixelRatio || 1);
	    window.onresize = function(){
	        init(window.devicePixelRatio || 1,true);
	    };
	    
	    
	    
	    $('#data-Backtrack').click(function(e){
	    	try{
	    		$.callBack(function(){
					//返回上一页
					
	    		},function(){
	    			//关闭H5窗口
	    			JSBridge.call('bridge','colsePage',{},function(res){
					})
	    		})
	    	}catch (e){
	    		console.error('页面未定义返回按钮执行事件,需将“callBack”方法挂载到window对象下')
	    	}finally{
	    		
	    	}
	    })
	    //监听页面点击返回按钮
	})();



	//JSBridge方法,所有前端代码与JAVA的通信入口及协议
	/*
	调用方法：

		JSBridge.call('bridge','方法名称',{传给JAVA的数据},function(callback回调的数据){
			//alert(JSON.stringify(res))
		})

	所有方法将在同级目录下的./H5-JAVA-protocol.md 文件全部说明--
	 */
	(function (win) {
	    var hasOwnProperty = Object.prototype.hasOwnProperty;
	    var JSBridge = win.JSBridge || (win.JSBridge = {});
	    var JSBRIDGE_PROTOCOL = 'JSBridge';
	    var Inner = {
	        callbacks: {},
	        call: function (obj, method, params, callback) {
//	            console.log(obj+" "+method+" "+params+" "+callback);
	            var port = Util.getPort();
	            this.callbacks[port] = callback;
	            var uri=Util.getUri(obj,method,params,port);
	            console.log(uri);
	            //window.prompt是为了让JAVA拦截，并接受参数，所有参数拼接在uri参数中。
	            window.prompt(uri, "");
	        },
	        onFinish: function (port, jsonObj){
	            var callback = this.callbacks[port];
	            callback && callback(jsonObj);
	            delete this.callbacks[port];
	        },
	    };
	    var Util = {
	        getPort: function () {
	            return Math.floor(Math.random() * (1 << 30));
	        },
	        getUri:function(obj, method, params, port){
	            params = this.getParam(params);
	            var uri = JSBRIDGE_PROTOCOL + '://' + obj + ':' + port + '/' + method + '?' + params;
	            return uri;
	        },
	        getParam:function(obj){
	            if (obj && typeof obj === 'object') {
	                return JSON.stringify(obj);
	            } else {
	                return obj || '';
	            }
	        }
	    };
	    for (var key in Inner) {
	        if (!hasOwnProperty.call(JSBridge, key)) {
	            JSBridge[key] = Inner[key];
	        }
	    }
	})(window);
	

	//  方法内聚
	var page = {
		dom : function(domName, className, id) {
			var classnameText = $.trim(className),
				idText = $.trim(id);
			if(className){//如果有class或者ID
				if(classnameText.indexOf('#') == 0){
					return $("<" + domName + ">").attr('id',className.slice(1,className.length));
				}else{
					if(idText){
						return $("<" + domName + ">").addClass(className).attr('id',id.slice(1,id.length));
					}else{
						return $("<" + domName + ">").addClass(className);
					}
					
				}
			}else{//单独创建DOM
				return $("<" + domName + ">")
			}
			
		},
		mask:function(opction){

		},
		
	};




	///////////////////-----------------     $ 扩展     ------

	//弹出小提示
	$.tips = function(text,time){
		var tips = {
			text : text || '',
			time : time || 2000
		}
		var tipsID = document.getElementById('domTipsID');
		if(!tipsID){
			var tipsHtml = '<div id="domTipsID"><p class="p_show">'+tips.text+'</p></div>';	
			$('body').append(tipsHtml)
		}else{
			document.getElementById('domTipsID').outerHTML = '';
			return;
		}
		setTimeout(function(){
			$('#domTipsID p').removeClass('p_show')
		},tips.time - 500)

		setTimeout(function(){
			document.getElementById('domTipsID').outerHTML = '';
		},tips.time)
	}


	/* 弹出层
		opction{
			id:'thisid',  				//弹出层的新ID,需要通过新ID去获取弹出层的信息
			content:'<div></div>',   	//弹出层的类容 可以是 html拼接，可以是dom节点
			title:'这是标题',
			area:['50%','auto','20%','20%'],     	//弹出层宽高上左,自定义设置,单位必填
			btn:['确定','取消'],		//按钮，单个按钮去掉取消
			yes:function(d){},			//确定回调
			no:function(d){}			//取消回调
		}
	*/
	$.popup = function(opction){
		var id = opction.id || '#popupId',
			content = opction.content || '',
			title = opction.title || '',
			area = opction.area || ['50%','auto','20%','20%'],
			btn = opction.btn || ['确定','取消'],
			creat = opction.creat || function(){},
			yes = opction.yes || function(){},
			no = opction.no || function(){};

			index = Date.parse(new Date());//通过回调的index来关闭弹窗

		// 设置弹窗底部样式
		var popHtml = $.dom('div','popup '+index);
			popHtml.append($.dom('div','mask'));


		var popupBox = $.dom('div','popupBox',id),
			popupTitle = $.dom('div','popupTitle'),
			popupContent = $.dom('div','popupContent'),


			popupFooter = $.dom('div','popupFooter'),
			popupBtnYes = $.dom('button','popupyesBtn'),
			popupBtnNo = $.dom('button','popupnoBtn');

			popupBox.id = id;


			popupTitle.text(title);
			popupContent.html(content);



			// 设置按钮
			popupBtnYes.attr('type','button');
			popupBtnNo.attr('type','button');
			
			

			if(btn.length == 2){
				popupBtnNo.text(btn[1]);
				popupFooter.append(popupBtnNo);
			}
			popupBtnYes.text(btn[0]);
			popupFooter.append(popupBtnYes);
			




			//设置弹出层样式
			if(area[0]){
				popupBox.css('width',area[0])
			}
			if(area[1]){
				popupBox.css('height',area[1])
			}
			if(area[2]){
				popupBox.css('top',area[2])
			}
			if(area[3]){
				popupBox.css('left',area[3])
			}




			//将内容信息传到弹出层中
			popupBox.append(popupTitle);
			popupBox.append(popupContent);
			popupBox.append(popupFooter);



			//将弹出层传到页面上
			popHtml.append(popupBox);
			$('body').append(popHtml);

			creat(index);


			//事件监听及回调
			popupBtnYes.click(function(e){
				yes(index,e)
			});

			popupBtnNo.click(function(e){
				no(index,e)
			})
		


	}




	// 关闭弹窗
	$.popupClose = function(index){
		//关闭弹窗的index是由创建弹窗的时候创建的时间戳，并添加在class中。
		var popupDom = document.getElementsByClassName(index);
		popupDom[0].outerHTML = '';
	}






	// 页面加载动画
	$.pageLoading = function(opction){

	}




	// 请求加载动画
	$.loading = function(text){
		if(text=='close'){
			//关闭加载动画
			var popupDom = document.getElementsByClassName('loading');
			popupDom[0].outerHTML = '';
		}else{
			var loadingHTML = '',
				getLoadingText = text || '';
				
				
				
			var loading = $.dom('div','loading'),
				mask = $.dom('div','mask'),
				loadingBox = $.dom('div','loadingBox loadingBox_1'),
				loadingImg = $.dom('i','loading_o'),
				loadingText = $.dom('div','loadingText'),
				loadingText_p = $.dom('p')

			
			
			loadingBox.append(loadingImg);
			loadingText.append(loadingText_p);
			loading.append(mask).append(loadingBox).append(loadingText);
			
			
			
			loadingText_p.text(getLoadingText)
			
			$('body').append(loading);
			
			
			//10秒之后自动异常提示
			setTimeout(function(){
				var popupDom = document.getElementsByClassName('loading');
				popupDom[0].outerHTML = '';
				$.tips('加载超时...')
			},10000)
			
		}

	}



	// 创建页面dom
	$.dom = page.dom;



	// 暴露方法
	return {
		page:page
	};
})