require.config({
    baseUrl: './',
    urlArgs: 'version=' + new Date().getTime(),
    waitSeconds: '0',
    paths: {
        zepto: 'libs/zepto.min',
        common: 'common/common',
    }
});

require(['zepto','common'], function ($,cm) {


	//填充用户信息
	JSBridge.call('bridge','getPersonInfo',{},function(res){
		if(res.errorCode){
			$.tips(res.errorMsg || '获取用户信息失败！',3000);
			return;
		}
		
		
		//render
		$('.userName').text(res.username);//姓名
		$('.mobile').text(res.mobile);//电话
		
		
		
		
		//身份证号
		var userIdCard = '';
		if(res.idCard){
			var card = res.idCard;
			userIdCard = card.substring(0,4)+'**********'+card.substring(14);
		};
		$('.idCard').text(userIdCard)
	})
	
	
	
	
	
	
	
	
	
	//左上角返回按钮点击关闭页面之前执行
	/*
	 * 通过 id = data-Backtrack 的标签来关闭页面，
	 */
	$.callBack = function(up,close){
		//up()返回上一页
		close();//关闭窗口。返回原生APP
	}
	
	
	
	
	
	
	//点击二维码
	$('.QRCode').click(function(){
		JSBridge.call('bridge','jumpToQRActivity',{},function(res){
		    
		})
	})
	
	
	
	

	//获取地址信息
	
	JSBridge.call('bridge','getAddress',{},function(res){
		$('.getAddress').text(res.province.dist_cn_name + res.city.dist_cn_name);
	})
	


	
	
	
	//修改手机号
	$('.editTel').click(function(){
		EditTel()
	})

	function EditTel(){
		//弹窗组件已封装
		$.popup({
			id:'#verifyAccountPOP',//注意带#号
			content:'<div class="verification"><p>为保证您的账户安全,修改手机号前请输入账户密码</p><input class="userVer"/></div>',
			title:'验证账户',
			area:['70%','auto','-10rem','-38%'],//定位-宽、高、上、左,需要带单位
			btn:['确定','取消'],
			creat:function(index){//弹出层创建完成之后立即调用,此时可以通过  ID+class获取到content中的信息。
				$('#verifyAccountPOP .userVer').focus();
			},
			yes:function(index,data){//点击确定按钮调用
				$.loading()
				var password = $('#verifyAccountPOP .userVer').val();
				JSBridge.call('bridge','verifyAccount',{password:password},function(res){
					$.loading('close')
					if(res.erroMsg){
						$.tips(res.erroMsg,3000)
					}else{
						$.popupClose(index);//关闭弹窗
					}
				})
				$.popupClose(index);//关闭弹窗
				
			},
			no:function(index,data){//点击取消按钮调用
				$.popupClose(index);//关闭弹窗
			}
		})
	}



})